/**********************************************
*  MP3ĐvO VAR}hMo[W@
*  Ver 1.00 REV 02  
*  2015/11/29  rev02 f[^Mgetchar()U1RXREG̃WX^ɕύX
*  mp3Sv1.c : MP3ĐvO
*  VAR}h󂯂ċȂ̍Đ(300bps)
*  SDJ[hMP3̃t@C̓[gɂ̂ݕۑ
*  fBNg͈ĂȂ̂Ŗ

*  PIC24FJ64GA004
*  Cu
*  	FSIO.h		Microchip Memory Disk Drive File System
*  	SD-SPI.h	Microchip Memory Disk Drive File System
*@@	VS1011.h	VS1011E@䃉Cu(http://www.picfun.com/) 
@@@@@@@@@@@@@@http://www.picfun.com/PIC24F/AP/app24F08.html

***********************************************/
#include <p24FJ64GA004.h>
#include "GenericTypeDefs.h"
#include "FSIO.h"
#include "VS1011.h"

/* RtBM[V rbg̐ݒ  */
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF &	BKBUG_OFF
	 & COE_OFF & ICS_PGx1& FWDTEN_OFF ) 
/* 8MHz*PLL4=32MHz (Full Speed)  */
_CONFIG2( IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD
	 & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)

/**********************************************
***********************************************/

/* FATt@Cp\̂̃|C^ϐ  */
FSFILE *fptr;
size_t result;
BYTE Buffer[256];
SearchRec Record;
SearchRec *rptr = &Record;

int i;			//JE^p
int scnt;		//XCb`I̔ԍ
int OpFlg;		//t@CI[vtO
int EndFlg;     //ItO
/*VAMpϐ@@*/

char recvbuf[10];	//Mobt@
int counter;		//MoCgJE^
char recvcomp;		//R}h̃f~^܂ŎMoƂ̎MtO
int RecvVal;		//MR}ht@NVԍɕύX
int onoff_flg;		//t@NVnmEneẽtO
int hcmd;			//16i琔lϊp
int Clock_tab;		//NbN^uݒl
int Repeat_flg;		//s[gtO

int val;

BYTE RunMode;   //s[h@iFalseŃ[^@TrueŒPnmj
/* MP3pϐ  */
BYTE Volume, ChgFlag, PlyFlag, BASS;
/* ֐vg^CsO  */
void CmdProcess(void);	
void ParamConv(void);
/**************************
* C֐
***************************/
int main(void){
	CLKDIV = 0;							// NbN1/1
	/* o̓|[gݒ  */
	AD1PCFG = 0xFFFF;					// ׂăfW^
//	TRISA = 0xFFFC;						// RA0,1̂ݏo
	TRISA = 0xFF7C;						// RA0,1,7̂ݏo
	TRISB = 0x450F;						// RB0-3,8,10,14 0100 0101 0000 1111
	TRISC = 0x03C7;						// RC0,1,6,7,8,9
	CNPU1 = 0x17F0;						// CN4-7,8-10,12  0001 0111 1111 0000
	CNPU2 = 0x60FF;						// CN16-23,29,30  0110 0000 1111 1111
	/* XCb`ԕω荞݂̋  */
//														0	 7    F    0
//	CNEN1 = 0x07F0;						// CN4-7,8-10  0000 0111 1111 0000
//														2	 0	  1	   E
//	CNEN2 = 0x201E;						// CN17-20,29  0010 0000 0001 1110
//	IPC4bits.CNIP = 5;
//	IEC1bits.CNIE = 1;

	/*VA|[Ă̊荞݂̋  */
	RPINR18bits.U1RXR = 3;    			//M@RP3 24ԃs蓖
	RPOR1bits.RP2R = 3;					//M@RP2 23ԃs蓖
	RPOR4bits.RP9R = 4;					//RTS RP9 1ԃs蓖

	/*USRTݒ@9600bps@8bit non-p non-flow@*/
	U1BRG = 13332;							//9600bps 16MHz
	U1MODE = 0b1000001000001000;		//lncdWX^LEݒ
//			   1000 0010 0000 0000	
	U1STA  = 0b0000000000000000;		//MԂ̃WX^(M͖j

	IPC2bits.U1RXIP = 7;				//荞݂̗Dxݒ
	IEC0bits.U1RXIE = 1;				//VA荞݋

	/* SPĨst  */
	RPINR20bits.SDI1R = 7;				// SDI1RP7
	RPOR3bits.RP6R = 8;					// SCK1RP6
	RPOR2bits.RP5R = 7;					// SDO1RP5
	RPINR22bits.SDI2R = 10;				// SDI2RP10
	RPOR6bits.RP12R = 11;				// SCK2RP12
	RPOR5bits.RP11R = 10;				// SDO2RP11

	/*@VAMϐ̏@*/
	counter = 0;
	recvcomp = 0;
	/*@VS1011ȅ@*/
	VS1011_Init();
	Volume = 0x00;									// ʂ̏ݒ
	SetVolume(Volume, Volume);
	BASS = 0;										// oXu[Xg̏ݒ
	SetBassBoost(BASS,15);
	Clock_tab = 128;								//NbN^ul

	/* VS1011̃fobOeXgp̃R}h@@*/
// 	VS1011_SineTest();								// go̓eXg

	/*t@CI[vtO */
	OpFlg = 0;

	/* J[h̎mFƃfBNgǂݍ iiv҂j */
	while(!FSInit());								// FAT̏

	while(1){
		while(1){
			/* XCb`荞݂邩`FbN*/
			if(ChgFlag){							//XCb`̕ύX
				ChgFlag = 0; 
				/* ŏ̃t@C */
				result = FindFirst("*.*", ATTR_ARCHIVE, rptr);
				if(result == 0){
				}
				else{
					/*t@CłȂꍇ̓[vo */
					break;
				}	
				/* w蕪t@CXLbv */
				for (i=1; i<=scnt; ++i){
					result = FindNext(rptr);			// ̃t@C
					if((result==0)&&(Record.attributes==ATTR_ARCHIVE)){
					}
					else{
						/*t@CłȂꍇ̓[vo */
						break;
					}	
				}
				/* w̃t@CI[v */
				fptr = FSfopen(Record.filename, "r");		// t@C̃I[v
				if(result==0){
					OpFlg = 1;
				}
				else{
					/*t@CI[vłȂꍇ̓[vo */
					break;
				}	

				/* yf[^̏o */
				if(fptr != 0){								// ɃI[vłH
					/* {[̒ ------------*/
						SetVolume(Volume, Volume);
					/* NbN^u̒ ------------*/
					/*NbN24.576MHZȂ̂ł̒l炷ƉωiȂj */
						val =(192000 * Clock_tab ) / 2000;		// ݒl߂if[^V[gj
						CmdCheck(0x03, (BYTE)(val /256), (BYTE)val);
						delay_ms(10);
					/* -------------------------- */

					/* t@CEOF܂ŉf[^Ao */
					do{
						/* yf[^̑M@*/
						SRbits.IPL = 6;						// SPI͊荞݋֎~
						MP3_XDCS_IO = 0;
						/* 32oCgPʂŃt@C[h@*/
						result = FSfread(Buffer, 1, 256, fptr);
						for(i= 0; i<result; i++){			// ǂݏooCgJԂ
							SendData(Buffer[i]);			// yf[^M
						}
						SRbits.IPL = 2;						// 荞ݍċ
						if(EndFlg){							//ItONA@
							EndFlg = 0;
						break;
						}
						if(U1STAbits.OERR || U1STAbits.FERR) //obt@I[o[t~OG[
						{
							U1STA &= 0xfff0;			//G[tONA
							counter = 0;
						}
					} while(result != 0);					// t@CEOF܂Ōp
					MP3_XDCS_IO = 1;
					/* Đ	*/
					FSfclose(fptr);							// t@C̃N[Y
					OpFlg = 0;
					PlayEnd();								// ĐI
				}
				else{
					OpFlg = 0;
				}
				//JԂĐChgFlag=1ɂ
				if (Repeat_flg == 1){
				ChgFlag = 1;
				}
			}
			if(U1STAbits.OERR || U1STAbits.FERR) //obt@I[o[t~OG[
			{
				U1STA &= 0xfff0;			//G[tONA
				counter = 0;
			}
		}
	}
}


/*-VAʐMɂ銄---------
@UART1RX UART1M

-------------------------------*/
void __attribute__((interrupt, auto_psv)) _U1RXInterrupt(void){

	IFS0bits.U1RXIF = 0;		//VA荞݃tO
	unsigned int ic;			//obt@NApJE^
	unsigned char cmnd;			//VAM̕

//VAf[^̎M
	if(U1STAbits.OERR || U1STAbits.FERR) //obt@I[o[t~OG[
	{
		U1STA &= 0xfff0;			//G[tONA
		counter = 0;
	}
	else
	{
		cmnd = U1RXREG;			//M̎擾(WX^QƁj

		/*R}h̏*/
		if(counter >= sizeof(recvbuf)) 	//obt@I[o[ɂȂ烊Zbg
		{	
			counter = 0;
		}
		else 
		{
			if(cmnd == ';') 	//@;̓R}h̏I	
			{
				CmdProcess();		//M̏
				counter = 0;
				RecvVal = 0;
				for (ic=0; ic<sizeof(recvbuf); ic++)	//Mobt@NA
					recvbuf[ic] = ' ';
			}
			else
   		    {
	 			recvbuf[counter] = cmnd;
				counter++;
			}
		
		}
	}
}


void CmdProcess() {

	if(recvbuf[0] == 'V'){
//		{[R}h̏
//		00ōő@edōŏ@@eeŏȓd
		ParamConv();
        Volume = hcmd;
	}
	if(recvbuf[0] == 'C'){
//		NbN^ȕ
//		00F@01~FFŐݒ@@80HŕW
		ParamConv();
        Clock_tab = hcmd;
	}

	if(recvbuf[0] == 'S'){
//		Đ~R}h
        EndFlg = 1;
		Repeat_flg = 0;
	}


	if(recvbuf[0] == 'F' || recvbuf[0] == 'R')
	{
		switch(recvbuf[1])
		{
			case '1':
				RecvVal = 10;
				break;
			case '2':		
				RecvVal = 20;
				break;
		}	
		switch(recvbuf[2])
		{
			case '0':
				RecvVal += 0;
				break;
			case '1':
				RecvVal += 1;
				break;
			case '2':		
				RecvVal += 2;
				break;
			case '3':		
				RecvVal += 3;
				break;
			case '4':
				RecvVal += 4;
				break;
			case '5':		
				RecvVal += 5;
				break;
			case '6':		
				RecvVal += 6;
				break;
			case '7':
				RecvVal += 7;
				break;
			case '8':		
				RecvVal += 8;
				break;
			case '9':		
				RecvVal += 9;
				break;
		}	
		if(recvbuf[0] == 'R'){
		//qR}h͌JԂĐ@Ȃ̂Ł@	Repeat_flg  1@ɂ
			Repeat_flg = 1;
 		}
		else{
			Repeat_flg = 0;
		}

	/* R}hȔԑI */
		ChgFlag = 1;
		scnt = RecvVal;
		if (OpFlg == 1){
			EndFlg = 1;
			FSfclose(fptr);		// ݂̃t@CN[Y
			PlayEnd();			// ĐI
		}
	}  //if (recvbuf[0] == 'F')

}

void ParamConv(void) {
//16i𐔒lɕϊ
		switch(recvbuf[1])
		{
			case '0':
				hcmd = 0;
				break;
			case '1':
				hcmd = 16;
				break;
			case '2':		
				hcmd = 32;
				break;
			case '3':		
				hcmd = 48;
				break;
			case '4':		
				hcmd = 64;
				break;
			case '5':		
				hcmd = 80;
				break;
			case '6':		
				hcmd = 96;
				break;
			case '7':		
				hcmd = 112;
				break;
			case '8':		
				hcmd = 128;
				break;
			case '9':		
				hcmd = 144;
				break;
			case 'A':		
				hcmd = 160;
				break;
			case 'B':		
				hcmd = 176;
				break;
			case 'C':		
				hcmd = 192;
				break;
			case 'D':		
				hcmd = 208;
				break;
			case 'E':		
				hcmd = 224;
				break;
			case 'F':		
				hcmd = 240;
				break;
		}	
		switch(recvbuf[2])
		{
			case '0':
				hcmd += 0;
				break;
			case '1':
				hcmd += 1;
				break;
			case '2':		
				hcmd += 2;
				break;
			case '3':		
				hcmd += 3;
				break;
			case '4':
				hcmd += 4;
				break;
			case '5':		
				hcmd += 5;
				break;
			case '6':		
				hcmd += 6;
				break;
			case '7':
				hcmd += 7;
				break;
			case '8':		
				hcmd += 8;
				break;
			case '9':		
				hcmd += 9;
				break;
			case 'A':
				hcmd += 10;
				break;
			case 'B':		
				hcmd += 11;
				break;
			case 'C':		
				hcmd += 12;
				break;
			case 'D':
				hcmd += 13;
				break;
			case 'E':		
				hcmd += 14;
				break;
			case 'F':		
				hcmd += 15;
				break;
		}	

}

